/*
 * Automatically generated by asn1_compiler.  Do not edit
 *
 * ASN.1 parser for pkcs7
 */
#include <linux/asn1_ber_bytecode.h>
#include "pkcs7-asn1.h"

enum pkcs7_actions {
	ACT_pkcs7_extract_cert = 0,
	ACT_pkcs7_note_OID = 1,
	ACT_pkcs7_note_certificate_list = 2,
	ACT_pkcs7_note_data = 3,
	ACT_pkcs7_note_signed_info = 4,
	ACT_pkcs7_sig_note_authenticated_attr = 5,
	ACT_pkcs7_sig_note_digest_algo = 6,
	ACT_pkcs7_sig_note_issuer = 7,
	ACT_pkcs7_sig_note_pkey_algo = 8,
	ACT_pkcs7_sig_note_serial = 9,
	ACT_pkcs7_sig_note_set_of_authattrs = 10,
	ACT_pkcs7_sig_note_signature = 11,
	NR__pkcs7_actions = 12
};

static const asn1_action_t pkcs7_action_table[NR__pkcs7_actions] = {
	[   0] = pkcs7_extract_cert,
	[   1] = pkcs7_note_OID,
	[   2] = pkcs7_note_certificate_list,
	[   3] = pkcs7_note_data,
	[   4] = pkcs7_note_signed_info,
	[   5] = pkcs7_sig_note_authenticated_attr,
	[   6] = pkcs7_sig_note_digest_algo,
	[   7] = pkcs7_sig_note_issuer,
	[   8] = pkcs7_sig_note_pkey_algo,
	[   9] = pkcs7_sig_note_serial,
	[  10] = pkcs7_sig_note_set_of_authattrs,
	[  11] = pkcs7_sig_note_signature,
};

static const unsigned char pkcs7_machine[] = {
	// PKCS7ContentInfo
	[   0] = ASN1_OP_MATCH,
	[   1] = _tag(UNIV, CONS, SEQ),
	// ContentType
	[   2] =  ASN1_OP_MATCH_ACT,
	[   3] =  _tag(UNIV, PRIM, OID),
	[   4] =  _action(ACT_pkcs7_note_OID),
	[   5] =  ASN1_OP_MATCH_JUMP_OR_SKIP,		// content
	[   6] =  _tagn(CONT, CONS,  0),
	[   7] =  _jump_target(10),
	[   8] = ASN1_OP_END_SEQ,
	[   9] = ASN1_OP_COMPLETE,

	// SignedData
	[  10] =  ASN1_OP_MATCH,
	[  11] =  _tag(UNIV, CONS, SEQ),
	[  12] =   ASN1_OP_MATCH,		// version
	[  13] =   _tag(UNIV, PRIM, INT),
	// DigestAlgorithmIdentifiers
	[  14] =   ASN1_OP_MATCH_JUMP_OR_SKIP,		// daSet
	[  15] =   _tag(UNIV, CONS, SET),
	[  16] =   _jump_target(54),
	[  17] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// daSequence
	[  18] =   _tag(UNIV, CONS, SEQ),
	[  19] =   _jump_target(60),
	[  20] =   ASN1_OP_COND_FAIL,
	// ContentInfo
	[  21] =   ASN1_OP_MATCH,
	[  22] =   _tag(UNIV, CONS, SEQ),
	// ContentType
	[  23] =    ASN1_OP_MATCH_ACT,
	[  24] =    _tag(UNIV, PRIM, OID),
	[  25] =    _action(ACT_pkcs7_note_OID),
	[  26] =    ASN1_OP_MATCH_JUMP_OR_SKIP,		// content
	[  27] =    _tagn(CONT, CONS,  0),
	[  28] =    _jump_target(66),
	[  29] =   ASN1_OP_END_SEQ,
	// ExtendedCertificatesAndCertificates
	[  30] =   ASN1_OP_MATCH_JUMP_OR_SKIP,		// certSet
	[  31] =   _tagn(CONT, CONS,  0),
	[  32] =   _jump_target(70),		// --> ExtendedCertificatesAndCertificates
	// Certificates
	[  33] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// certSequence
	[  34] =   _tagn(CONT, CONS,  2),
	[  35] =   _jump_target(78),		// --> Certificates
	[  36] =   ASN1_OP_ACT,
	[  37] =   _action(ACT_pkcs7_note_certificate_list),
	// CertificateRevocationLists
	[  38] =   ASN1_OP_MATCH_JUMP_OR_SKIP,		// crlSet
	[  39] =   _tagn(CONT, CONS,  1),
	[  40] =   _jump_target(83),		// --> CertificateRevocationLists
	// CRLSequence
	[  41] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// crlSequence
	[  42] =   _tagn(CONT, CONS,  3),
	[  43] =   _jump_target(89),		// --> CRLSequence
	// SignerInfos
	[  44] =   ASN1_OP_MATCH_JUMP_OR_SKIP,		// siSet
	[  45] =   _tag(UNIV, CONS, SET),
	[  46] =   _jump_target(95),
	[  47] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// siSequence
	[  48] =   _tag(UNIV, CONS, SEQ),
	[  49] =   _jump_target(101),
	[  50] =   ASN1_OP_COND_FAIL,
	[  51] =  ASN1_OP_END_SEQ,
	[  52] = ASN1_OP_END_SEQ,
	[  53] = ASN1_OP_RETURN,

	// DigestAlgorithmIdentifier
	[  54] =  ASN1_OP_MATCH_JUMP,
	[  55] =  _tag(UNIV, CONS, SEQ),
	[  56] =  _jump_target(107),		// --> DigestAlgorithmIdentifier
	[  57] = ASN1_OP_END_SET_OF,
	[  58] = _jump_target(54),
	[  59] = ASN1_OP_RETURN,

	// DigestAlgorithmIdentifier
	[  60] =  ASN1_OP_MATCH_JUMP,
	[  61] =  _tag(UNIV, CONS, SEQ),
	[  62] =  _jump_target(107),		// --> DigestAlgorithmIdentifier
	[  63] = ASN1_OP_END_SEQ_OF,
	[  64] = _jump_target(60),
	[  65] = ASN1_OP_RETURN,

	// Data
	[  66] =  ASN1_OP_MATCH_ANY_ACT,
	[  67] =  _action(ACT_pkcs7_note_data),
	[  68] = ASN1_OP_END_SEQ,
	[  69] = ASN1_OP_RETURN,

	// ExtendedCertificateOrCertificate
	// Certificate
	[  70] =  ASN1_OP_MATCH_ANY_ACT_OR_SKIP,
	[  71] =  _action(ACT_pkcs7_extract_cert),
	// ExtendedCertificate
	// Certificate
	[  72] =  ASN1_OP_COND_MATCH_ANY_ACT_OR_SKIP,
	[  73] =  _action(ACT_pkcs7_extract_cert),
	[  74] =  ASN1_OP_COND_FAIL,
	[  75] = ASN1_OP_END_SET_OF,
	[  76] = _jump_target(70),
	[  77] = ASN1_OP_RETURN,

	// Certificate
	[  78] =  ASN1_OP_MATCH_ANY_ACT,
	[  79] =  _action(ACT_pkcs7_extract_cert),
	[  80] = ASN1_OP_END_SEQ_OF,
	[  81] = _jump_target(78),
	[  82] = ASN1_OP_RETURN,

	// CertificateList
	[  83] =  ASN1_OP_MATCH_JUMP,
	[  84] =  _tag(UNIV, CONS, SEQ),
	[  85] =  _jump_target(113),		// --> CertificateList
	[  86] = ASN1_OP_END_SET_OF,
	[  87] = _jump_target(83),
	[  88] = ASN1_OP_RETURN,

	// CertificateList
	[  89] =  ASN1_OP_MATCH_JUMP,
	[  90] =  _tag(UNIV, CONS, SEQ),
	[  91] =  _jump_target(113),		// --> CertificateList
	[  92] = ASN1_OP_END_SEQ_OF,
	[  93] = _jump_target(89),
	[  94] = ASN1_OP_RETURN,

	// SignerInfo
	[  95] =  ASN1_OP_MATCH_JUMP,
	[  96] =  _tag(UNIV, CONS, SEQ),
	[  97] =  _jump_target(118),		// --> SignerInfo
	[  98] = ASN1_OP_END_SET_OF,
	[  99] = _jump_target(95),
	[ 100] = ASN1_OP_RETURN,

	// SignerInfo
	[ 101] =  ASN1_OP_MATCH_JUMP,
	[ 102] =  _tag(UNIV, CONS, SEQ),
	[ 103] =  _jump_target(118),		// --> SignerInfo
	[ 104] = ASN1_OP_END_SEQ_OF,
	[ 105] = _jump_target(101),
	[ 106] = ASN1_OP_RETURN,

	[ 107] =  ASN1_OP_MATCH_ACT,		// algorithm
	[ 108] =  _tag(UNIV, PRIM, OID),
	[ 109] =  _action(ACT_pkcs7_note_OID),
	[ 110] =  ASN1_OP_MATCH_ANY_OR_SKIP,		// parameters
	[ 111] = ASN1_OP_END_SEQ,
	[ 112] = ASN1_OP_RETURN,

	// Certificate
	[ 113] =  ASN1_OP_MATCH_ANY_ACT,
	[ 114] =  _action(ACT_pkcs7_extract_cert),
	[ 115] = ASN1_OP_END_SEQ_OF,
	[ 116] = _jump_target(113),
	[ 117] = ASN1_OP_RETURN,

	[ 118] =  ASN1_OP_MATCH,		// version
	[ 119] =  _tag(UNIV, PRIM, INT),
	// IssuerAndSerialNumber
	[ 120] =  ASN1_OP_MATCH,
	[ 121] =  _tag(UNIV, CONS, SEQ),
	// Name
	[ 122] =   ASN1_OP_MATCH,
	[ 123] =   _tag(UNIV, CONS, SEQ),
	// RelativeDistinguishedName
	[ 124] =    ASN1_OP_MATCH,
	[ 125] =    _tag(UNIV, CONS, SET),
	// AttributeValueAssertion
	[ 126] =     ASN1_OP_MATCH,
	[ 127] =     _tag(UNIV, CONS, SEQ),
	[ 128] =      ASN1_OP_MATCH_ACT,		// attributeType
	[ 129] =      _tag(UNIV, PRIM, OID),
	[ 130] =      _action(ACT_pkcs7_note_OID),
	[ 131] =      ASN1_OP_MATCH_ANY,		// attributeValue
	[ 132] =     ASN1_OP_END_SEQ,
	[ 133] =    ASN1_OP_END_SET_OF,
	[ 134] =    _jump_target(126),
	[ 135] =   ASN1_OP_END_SEQ_OF,
	[ 136] =   _jump_target(124),
	[ 137] =   ASN1_OP_ACT,
	[ 138] =   _action(ACT_pkcs7_sig_note_issuer),
	// CertificateSerialNumber
	[ 139] =   ASN1_OP_MATCH,
	[ 140] =   _tag(UNIV, PRIM, INT),
	[ 141] =   ASN1_OP_ACT,
	[ 142] =   _action(ACT_pkcs7_sig_note_serial),
	[ 143] =  ASN1_OP_END_SEQ,
	// DigestAlgorithmIdentifier
	[ 144] =  ASN1_OP_MATCH_JUMP,
	[ 145] =  _tag(UNIV, CONS, SEQ),
	[ 146] =  _jump_target(107),		// --> DigestAlgorithmIdentifier
	[ 147] =  ASN1_OP_ACT,
	[ 148] =  _action(ACT_pkcs7_sig_note_digest_algo),
	// SetOfAuthenticatedAttribute
	[ 149] =  ASN1_OP_MATCH_JUMP_OR_SKIP,		// aaSet
	[ 150] =  _tagn(CONT, CONS,  0),
	[ 151] =  _jump_target(178),		// --> SetOfAuthenticatedAttribute
	[ 152] =  ASN1_OP_MAYBE_ACT,
	[ 153] =  _action(ACT_pkcs7_sig_note_set_of_authattrs),
	[ 154] =  ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// aaSequence
	[ 155] =  _tagn(CONT, CONS,  2),
	[ 156] =  _jump_target(184),
	// DigestEncryptionAlgorithmIdentifier
	[ 157] =  ASN1_OP_MATCH,
	[ 158] =  _tag(UNIV, CONS, SEQ),
	[ 159] =   ASN1_OP_MATCH_ACT,		// algorithm
	[ 160] =   _tag(UNIV, PRIM, OID),
	[ 161] =   _action(ACT_pkcs7_note_OID),
	[ 162] =   ASN1_OP_MATCH_ANY_OR_SKIP,		// parameters
	[ 163] =  ASN1_OP_END_SEQ,
	[ 164] =  ASN1_OP_ACT,
	[ 165] =  _action(ACT_pkcs7_sig_note_pkey_algo),
	// EncryptedDigest
	[ 166] =  ASN1_OP_MATCH_ACT,
	[ 167] =  _tag(UNIV, PRIM, OTS),
	[ 168] =  _action(ACT_pkcs7_sig_note_signature),
	[ 169] =  ASN1_OP_MATCH_JUMP_OR_SKIP,		// uaSet
	[ 170] =  _tagn(CONT, CONS,  1),
	[ 171] =  _jump_target(193),
	[ 172] =  ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// uaSequence
	[ 173] =  _tagn(CONT, CONS,  3),
	[ 174] =  _jump_target(199),
	[ 175] = ASN1_OP_END_SEQ_ACT,
	[ 176] = _action(ACT_pkcs7_note_signed_info),
	[ 177] = ASN1_OP_RETURN,

	// AuthenticatedAttribute
	[ 178] =  ASN1_OP_MATCH_JUMP,
	[ 179] =  _tag(UNIV, CONS, SEQ),
	[ 180] =  _jump_target(205),		// --> AuthenticatedAttribute
	[ 181] = ASN1_OP_END_SET_OF,
	[ 182] = _jump_target(178),
	[ 183] = ASN1_OP_RETURN,

	[ 184] =  ASN1_OP_MATCH,		// aaSequence
	[ 185] =  _tag(UNIV, CONS, SEQ),
	// AuthenticatedAttribute
	[ 186] =   ASN1_OP_MATCH_JUMP,
	[ 187] =   _tag(UNIV, CONS, SEQ),
	[ 188] =   _jump_target(205),		// --> AuthenticatedAttribute
	[ 189] =  ASN1_OP_END_SEQ_OF,
	[ 190] =  _jump_target(186),
	[ 191] = ASN1_OP_END_SEQ,
	[ 192] = ASN1_OP_RETURN,

	// UnauthenticatedAttribute
	[ 193] =  ASN1_OP_MATCH_JUMP,
	[ 194] =  _tag(UNIV, CONS, SEQ),
	[ 195] =  _jump_target(216),		// --> UnauthenticatedAttribute
	[ 196] = ASN1_OP_END_SET_OF,
	[ 197] = _jump_target(193),
	[ 198] = ASN1_OP_RETURN,

	// UnauthenticatedAttribute
	[ 199] =  ASN1_OP_MATCH_JUMP,
	[ 200] =  _tag(UNIV, CONS, SEQ),
	[ 201] =  _jump_target(216),		// --> UnauthenticatedAttribute
	[ 202] = ASN1_OP_END_SEQ_OF,
	[ 203] = _jump_target(199),
	[ 204] = ASN1_OP_RETURN,

	[ 205] =  ASN1_OP_MATCH_ACT,		// type
	[ 206] =  _tag(UNIV, PRIM, OID),
	[ 207] =  _action(ACT_pkcs7_note_OID),
	[ 208] =  ASN1_OP_MATCH,		// values
	[ 209] =  _tag(UNIV, CONS, SET),
	[ 210] =   ASN1_OP_MATCH_ANY_ACT,
	[ 211] =   _action(ACT_pkcs7_sig_note_authenticated_attr),
	[ 212] =  ASN1_OP_END_SET_OF,
	[ 213] =  _jump_target(210),
	[ 214] = ASN1_OP_END_SEQ,
	[ 215] = ASN1_OP_RETURN,

	[ 216] =  ASN1_OP_MATCH_ACT,		// type
	[ 217] =  _tag(UNIV, PRIM, OID),
	[ 218] =  _action(ACT_pkcs7_note_OID),
	[ 219] =  ASN1_OP_MATCH,		// values
	[ 220] =  _tag(UNIV, CONS, SET),
	[ 221] =   ASN1_OP_MATCH_ANY,
	[ 222] =  ASN1_OP_END_SET_OF,
	[ 223] =  _jump_target(221),
	[ 224] = ASN1_OP_END_SEQ,
	[ 225] = ASN1_OP_RETURN,
};

const struct asn1_decoder pkcs7_decoder = {
	.machine = pkcs7_machine,
	.machlen = sizeof(pkcs7_machine),
	.actions = pkcs7_action_table,
};
